#pragma once

#include <vector>
#include <string>

class Config
{
    public:
        struct WLAN
        {
            std::string ssid;
            std::string password;
        };

        typedef std::vector<WLAN> WLANList;

        static Config &instance()
        {
            static Config theConfig;
            return theConfig;
        }

        void load(void);

        const WLANList& getWLANList(void) { return m_wlans; }

        const std::string& getCRPassword(void) { return m_crPassword; }
        const std::string& getCRSalt(void) { return m_crSalt; }

    private:
        Config();

        WLANList    m_wlans;
        std::string m_crPassword;
        std::string m_crSalt;
};