#pragma once

#include <string>

#include <FreeRTOS.h>
#include <freertos/semphr.h>

#include "ChallengeResponse.h"

class UpdateServer
{
    public:
        enum UpdateTypes {
            UT_FLASH = 0,
            UT_SPIFFS = 1
        };

        UpdateServer(const std::string &pw, SemaphoreHandle_t *ledLockoutMutex);

        void start(void);

    private:
        static void updateTask(void *arg);

        ChallengeResponse m_cr;
        SemaphoreHandle_t *m_ledLockoutMutex;
};
